import { INetRequest } from "../../script/Engine/CatanEngine/NetManagerV2/Core/INetRequest";
import { INetResponse } from "../../script/Engine/CatanEngine/NetManagerV2/Core/INetResponse";
import { ClientData } from "../../shared/protocols/define/interface";
import { RpcSlot1SpinRequest, RpcSlot1SpinResponse } from "../../shared/protocols/Slot1Request";

export default function* (clientData: ClientData, req: INetRequest<RpcSlot1SpinRequest>): IterableIterator<any> {
	const data: RpcSlot1SpinRequest = req.Data

	// const freeTemps: string[] = [
	// 	`{"slot":[13,9,5,14,4,9,4,12,12,11,4,14,8,7,6],"line":[[[10,6],195,300],[[10,6],213,300]]}`,
	// 	`{"slot":[9,9,10,13,4,5,4,3,4,11,10,14,14,14,5]}`,
	// 	`{"slot":[12,6,8,12,11,7,12,11,5,5,11,5,3,10,9]}`,
	// 	`{"slot":[4,6,11,13,8,12,12,3,4,10,7,5,14,14,4]}`,
	// 	`{"slot":[5,9,9,3,11,10,4,5,12,5,4,14,12,5,9],"line":[[[10,6],195,300],[[10,6],213,300]]}`,
	// 	`{"slot":[14,4,10,3,11,5,14,3,12,6,10,6,14,5,12],"line":[[[0,6,12],49,750]],"scatter":[[[3,7],3000]]}`,
	// 	`{"slot":[9,14,13,4,11,4,7,6,14,6,12,13,9,12,12]}`,
	// 	`{"slot":[10,3,12,13,5,6,4,8,4,9,13,14,11,14,4]}`,
	// 	`{"slot":[10,14,13,9,8,6,6,6,4,13,13,12,9,14,4],"line":[[[5,6,7],122,3000]]}`,
	// 	`{"slot":[11,13,9,8,5,8,5,5,13,9,14,9,12,4,7]}`,
	// ];
	// const Data: any = JSON.parse(freeTemps[RandomEx.GetInt(0, freeTemps.length)]);
	const { count, freeData } = clientData.free;
	const slotData: any = freeData[count];

	const response: INetResponse<RpcSlot1SpinResponse> = {
		Status: 0,
		Method: req.Method,
		Data: slotData,
		IsValid: true
	};
	clientData.free.count++;
	return response;
}